package common.controller;


import common.model.Menu;
import common.model.User;
import common.repository.MenuRepository;
import common.repository.UserRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import util.CipherUtil;
import util.ResultModel;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;


@Controller
@RequestMapping("login")
public class LoginController {

    protected Logger logger = LoggerFactory.getLogger(LoginController.class);

    @Autowired
    private UserRepository userRepository;

    @RequestMapping(value = "login", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel login(HttpServletResponse response, @RequestParam String email, @RequestParam String password) {
        User user = userRepository.login(email, CipherUtil.generatePassword(password));
        if(null != user){
            Cookie cookie = new Cookie("TOKEN", user.getId().toString());
            cookie.setPath("/");
            cookie.setMaxAge(60 * 60 * 24 * 7);
            response.addCookie(cookie);
            return ResultModel.OK(user);
        }
        return ResultModel.OK(false);
        }
    @RequestMapping(value = "login/check", method = RequestMethod.GET)
    @ResponseBody
    public ResultModel loginCheck(HttpServletResponse response, @RequestParam String email) {
        User user = userRepository.login(email);
        if(null != user){
            return ResultModel.OK(true);
        }
        return ResultModel.OK(false);
    }


}
