package security.interceptor;

import common.model.User;
import common.repository.UserRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class AuthorizationInterceptor extends HandlerInterceptorAdapter {
    private static final Logger logger = LoggerFactory.getLogger(AuthorizationInterceptor.class);
    //存放鉴权信息的Header名称，默认是Authorization
    public static String httpHeaderName = "Authorization";
    @Autowired
    private UserRepository userRepository;



    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) {
        //放开登录
        if (request.getRequestURL().indexOf("login/login") != -1){
            return true;
        }
        String token = request.getHeader(httpHeaderName);
        System.out.println(token);
        String id = getCookieToken(request.getCookies(), "TOKEN");
        if(null != id){
            User account = userRepository.findOne(Long.parseLong(id));
            User sessionAct = (User) request.getSession().getAttribute("$CURRENT_ACCOUNT$");
            if (sessionAct == null || !account.getId().equals(sessionAct.getId())) {
                request.getSession().setAttribute("$CURRENT_ACCOUNT$", account);
            }
            return true;
        }
        return false;
    }

    private String getCookieToken(Cookie[] cookies, String name){

        String token = null;

        if (null != cookies) {
            for (Cookie cookie : cookies) {
                if (cookie.getName().equals(name)) {
                    token = cookie.getValue();
                }
            }
        }

        return token;
    }
}